"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkQueryIncludeParam = void 0;
const param_case_1 = require("param-case");
async function checkQueryIncludeParam(queryParams, entityMetadata) {
    const errors = [];
    (queryParams["include" /* include */] || []).forEach(relationName => {
        const relation = entityMetadata.relations.find(relation => {
            return relation.propertyPath === relationName;
        });
        if (!relation) {
            errors.push({
                detail: `Relation '${param_case_1.paramCase(relationName)}' does not exist`,
                source: {
                    parameter: "include" /* include */,
                },
            });
        }
    });
    return errors;
}
exports.checkQueryIncludeParam = checkQueryIncludeParam;
//# sourceMappingURL=check-query-include-param.js.map